/***************************************************************************
 *                                                                         *
 *   kemboss - Graphical user interface for EMBOSS                         *
 *                                                                         *
 *   Copyright (C) 2007-2013 Tobias Schwarz (mail@tobias-schwarz.net)      *
 *                                                                         *
 *   Based on the EMBOSS.kaptn scripts by Thomas Siegmund                  *
 *                                                                         *
 *   This program is free software; you can redistribute and/or modify     *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version, and provided that the above       *
 *   copyright and permission notice is included with all distributed      *
 *   copies of this or derived software.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                         *
 **************************************************************************/

#ifndef ABOUT_H
#define ABOUT_H

#include <QNetworkAccessManager>
#include <QNetworkRequest>
#include <QNetworkReply>
#include <QPointer>
#include "ui_about.h"
#include "settings.h"
#include "runEmbossApp.h"

class versionCheck : public QObject
{
   Q_OBJECT

public:
   explicit versionCheck(QUrl versionUrl, QObject *parent = 0);
   virtual ~versionCheck();
   QByteArray downloadedData() const;

signals:
   void downloaded();

private slots:
   void versionDownloaded(QNetworkReply* pReply);

private:
    QNetworkAccessManager m_WebCtrl;
    QByteArray m_DownloadedData;
};

class aboutForm : public QDialog, private Ui::about
{
   Q_OBJECT

public:
   aboutForm(QWidget *parent = 0, kembossSettings *fksettings = 0);
   virtual ~aboutForm();

private slots:
   void on_GPLButton_clicked();
   void on_CopyrightButton_clicked();
   void on_URLButton_clicked();
   void showEmbossVersion();
   void showEmbossUpdate();
   void getLatestKembossVersion();

private:
   kembossSettings *ksettings;
   QPointer<krunEmbossApp> runEmbossVersion;
   QPointer<krunEmbossApp> runEmbossUpdate;
   versionCheck *m_pVersionCtrl;
};

#endif
