/***************************************************************************
 *                                                                         *
 *   kemboss - Graphical user interface for EMBOSS                         *
 *                                                                         *
 *   Copyright (C) 2007-2014 Tobias Schwarz (mail@tobias-schwarz.net)      *
 *                                                                         *
 *   Based on the EMBOSS.kaptn scripts by Thomas Siegmund                  *
 *                                                                         *
 *   This program is free software; you can redistribute and/or modify     *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version, and provided that the above       *
 *   copyright and permission notice is included with all distributed      *
 *   copies of this or derived software.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                         *
 **************************************************************************/

#ifndef SERVERSHARED_H
#define SERVERSHARED_H

#include <QString>

namespace kembossServer
{

enum threadStatus { ThreadStartingUp = 1,
                    TransferringConfiguration = 2,
                    TransferringFile = 3,
                    EmbossProgramRunning = 4,
                    ThreadCanceledByUser = 5,
                    TransferringEmbossOutput = 6,
                    ClosingConnection = 7
                  };

enum serverReturnCode { Success = 0,
                        UserIdentificationFailed = 1,
                        CanceledByUser = 2,
                        MaxExecTimeExceeded = 3,
                        ServerReceivedUnknownCommand = 4,
                        ExecutionOfProgramNotAllowed = 7,
                        EmbossBinaryNotFound = 5,
                        UnknownErrorOnEmbossRun = 6,
                        DataTransferTimeout = 7,
                        FileTransferError = 8,
                        FailedToStart = 9,
                        Crashed = 10,
                        Timedout = 11,
                        WriteError = 12,
                        ReadError = 13,
                        CheckServerSuccess = 14,
                        ClientServerConnectionFailed = 15
                      };

QByteArray SHA256hash(const QByteArray &pw);

QString getServerConfigFile();

void msgStdOut(const QString &msg, const QString &logfile = "stdout");
// Write a message to StdOut

void msgStdErr(const QString &msg, const QString &logfile = "stdout");
// Write a message to StdErr
}

#endif //SERVERSHARED_H
